#ifndef WTL
#define WTL
//*************************************************************************//
//*****************  :************************//
#include <alloc.h>    //    
#include <math.h>     // 
//*************************************************************************//
//*****************  :****************************//
typedef double real;
typedef long int integer;
typedef struct {real RE,IM;} complex;
typedef struct {complex *Mas;integer k;} scomplex;   
//*************************************************************************//
//*****************   :*********************//
//  
complex SET_ELEM(real R,real I) {
   complex Elem;
   Elem.RE=R,Elem.IM=I;
   return Elem;
}
//=========================================================================//
// 2 
complex SUM(complex a,complex b) {
   return SET_ELEM(a.RE+b.RE,a.IM+b.IM);
}
//=========================================================================//
// 2 
complex SUB(complex a,complex b) {
   return SET_ELEM(a.RE-b.RE,a.IM-b.IM);
}
//=========================================================================//
// 2 
complex MUL(complex a,complex b) {
   return SET_ELEM(a.RE*b.RE-a.IM*b.IM,a.RE*b.IM+a.IM*b.RE);
}
//=========================================================================//
// 
complex INV(complex a) {
   return SET_ELEM(a.RE,-a.IM);
}
//*************************************************************************//
//************** /   :********//
//  -:
#define TRIG_VARS    \
	scomplex S;  \
        integer i,k; \

//       k
scomplex SET_MAS(integer k) {
   scomplex S;
   S.k=k;
   S.Mas=(complex*)malloc(k*sizeof(complex));
   return S;
}
//=========================================================================//
//c 
scomplex COPY_MAS(scomplex A) {
   TRIG_VARS
   k=A.k;
   S=SET_MAS(k);
   for(i=0; i<k; i++) S.Mas[i]=A.Mas[i];
   return S;
}
//=========================================================================//
//c 
scomplex SUM_MAS(scomplex A,scomplex B) {
   TRIG_VARS
   k=A.k;
   S=SET_MAS(k);
   for(i=0; i<k; i++) S.Mas[i]=SUM(A.Mas[i],B.Mas[i]);
   return S;
}
//=========================================================================//
//***************    ********************//
//Ish-    k,
//flagOk>0  , 
scomplex FFT(scomplex Ish,integer flagOk)
{
    integer k,ii,jj,n,mmax,m,j,istep,i,isign;
    real wi,theta;
    complex temp,w,w1,w2;
    scomplex Res;

    Res=COPY_MAS(Ish);
    k=Ish.k;

    if(flagOk>0) isign= 1;
    else         isign=-1;

    n=k/2;
    j=0;
    for(i=0;i<k;i++) {
        if(j>i) {
            temp=Res.Mas[j];
            Res.Mas[j]=Res.Mas[i];
            Res.Mas[i]=temp;
        }
        m=n;
        while(m>0 && j>=m) j-=m,m/=2;
        j+=m;
    }
    mmax=1;
    while(k>mmax)
    {
        istep = 2*mmax;
        theta = M_PI/(isign*mmax);
        w1=SET_ELEM(-2*pow(sin(theta/2),2),sin(theta));
        w2=SET_ELEM(1,0);

        for(ii=0; ii<mmax; ii++) {
            wi=(real) (k-ii)/istep;
            for(jj=0; jj<wi; jj++) {
                i=ii+jj*istep;
                j=i+mmax;
                temp=MUL(Res.Mas[j],w2);
                Res.Mas[j]=SUB(Res.Mas[i],temp);
                Res.Mas[i]=SUM(Res.Mas[i],temp);
            }
            w2=SUM(w2,MUL(w1,w2));
        }
        mmax=istep;
    }
    if(flagOk<0)
       for(i=0;i<k;i++)
         Res.Mas[i]=SET_ELEM(Res.Mas[i].RE/k,Res.Mas[i].IM/k);
    return Res;
}
//*************************************************************************//
//   -:
//    
scomplex INV_MAS(scomplex a) {
    TRIG_VARS
    k=a.k;
    S=SET_MAS(k);
    for(i=0;i<k;i++)
      S.Mas[k-i-1]=INV(a.Mas[i]);
    return S;
};
//======================================================================
// 
scomplex DOWN(scomplex a, integer p) {
    TRIG_VARS
    integer j=pow(2,p);
    k=a.k/j;
    S=SET_MAS(k);
    for(i=0; i<k; i++)
      S.Mas[i]=a.Mas[j*i];
    return S;
};
//======================================================================
// 
scomplex UP(scomplex a, integer p) {
    TRIG_VARS
    integer j=pow(2,p);
    k=a.k*j;
    S=SET_MAS(k);
    for(i=0; i<k; i++) S.Mas[i]=SET_ELEM(0,0);
    for(i=0; i<a.k; i++) S.Mas[i*j]=SET_ELEM(a.Mas[i].RE,a.Mas[i].IM);
    return S;
};
//======================================================================
//
scomplex SVERTKA(scomplex a, scomplex b) {
    TRIG_VARS
    scomplex A_f,B_f;
    k=a.k;
    A_f=FFT(a,1);
    B_f=FFT(b,1);
    S=SET_MAS(k);
    for(i=0; i<k; i++)
       S.Mas[i]=MUL(A_f.Mas[i],B_f.Mas[i]);
    S=FFT(S,-1);
    return S;
};
//======================================================================
//   p  
scomplex R(scomplex a, integer p) {
    TRIG_VARS
    integer l=p;
    k=a.k;
    while(l>=k) l-=k;
    if(l) {
     S=SET_MAS(k);
     for(i=0;i<l;i++)
       S.Mas[i]=a.Mas[k+i-l];
     for(i=l;i<k;i++)
       S.Mas[i]=a.Mas[i-l];
     return S;
    }
    return a;
};
//======================================================================
// 2   
scomplex UNION(scomplex a, scomplex b) {
    TRIG_VARS
    k=a.k+b.k;
    S=SET_MAS(k);
    for(i=0;i<a.k;i++)
       S.Mas[i]=SET_ELEM(a.Mas[i].RE,a.Mas[i].IM);
    for(i=0;i<b.k;i++)
       S.Mas[i+a.k]=SET_ELEM(b.Mas[i].RE,b.Mas[i].IM);
    return S;
};
//*************************************************************************//
// 
scomplex* SET_SMAS(integer p) {
    scomplex *SMas;
    SMas=(scomplex*)malloc(p*sizeof(scomplex));
    return SMas;
}
//======================================================================
#define TRIG_FVARS                  \
    scomplex *UMas,*VMas,*Filtr;    \
    scomplex f,g;                   \
    integer i,n;                    \
    UMas =SET_SMAS(p);              \
    VMas =SET_SMAS(p);              \
    Filtr=SET_SMAS(p+1);

#define FUNC(NAME) NAME(n)

#define WORK(NAME)                  \
    n=k;                            \
    for(i=0;i<p;i++) {              \
      UMas[i]=U_##NAME##(n);        \
      VMas[i]=V_##NAME##(n);        \
      n/=2;          }              \
    for(i=1;i<=p;i++) {             \
      if(i==1)          {           \
        f=VMas[0];                  \
        g=UMas[0];  }               \
      else                        { \
        f=SVERTKA(g,UP(VMas[i-1],i-1));  \
        g=SVERTKA(g,UP(UMas[i-1],i-1)); }\
      n/=2;                              \
      Filtr[i-1]=f;                      \
    }                                    \
    Filtr[p]=g;

#define FREE_MEMORY                       \
    free(UMas);free(VMas);
//======================================================================
#define TRIG_VVARS   \
         scomplex S; \
         integer i;  \
         S=SET_MAS(k);
//======================================================================
// 
scomplex FWT(scomplex Ish,scomplex *Filtr,integer p) {
    scomplex S;
    integer i;
    S=DOWN(SVERTKA(Ish,INV_MAS(Filtr[0])),1);
    for(i=1; i<p; i++)
      S=UNION(S,DOWN(SVERTKA(Ish,INV_MAS(Filtr[i])),i+1));
    S=UNION(S,DOWN(SVERTKA(Ish,INV_MAS(Filtr[p])),p));
    return S;
}
//======================================================================
//  :
scomplex IFWT(scomplex Koeff,scomplex *Filtr,integer p) {
    scomplex S,T;
    integer i,k,j,e,n;
    k=Koeff.k, e=k/2, n=0;
    S=SET_MAS(k);
    for(i=0; i<k; i++) S.Mas[i]=SET_ELEM(0,0);
    for(i=0; i<p; i++) {
      T=SET_MAS(e);
      for(j=0; j<e; j++) T.Mas[j]=Koeff.Mas[n+j];
      n+=e, e/=2;
      S=SUM_MAS(S,SVERTKA(UP(T,i+1),Filtr[i]));
    }
    for(j=0; j<2*e; j++) T.Mas[j]=Koeff.Mas[n+j];
    S=SUM_MAS(S,SVERTKA(UP(T,p),Filtr[p]));
    S=R(S,1);
    return S;
}
//======================================================================
#endif






